package mirrg.swing.neon.v1_1;

import java.awt.Window;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowEvent;

public class NitrogenEventNeon
{

	public Window window;
	public Neon neon;

	public NitrogenEventNeon(Window window, Neon neon)
	{
		this.window = window;
		this.neon = neon;
	}

	public static class NitrogenEventNeonWindow extends NitrogenEventNeon
	{

		public WindowEvent event;

		public NitrogenEventNeonWindow(Window window, Neon neon, WindowEvent event)
		{
			super(window, neon);
			this.event = event;
		}

	}

	public static class NitrogenEventNeonComponent extends NitrogenEventNeon
	{

		public ComponentEvent event;

		public NitrogenEventNeonComponent(Window window, Neon neon, ComponentEvent event)
		{
			super(window, neon);
			this.event = event;
		}

	}

	/**
	 * 初回open時
	 */
	public static class Initialized extends NitrogenEventNeonComponent
	{

		public Initialized(Window window, Neon neon, ComponentEvent event)
		{
			super(window, neon, event);
		}

	}

	/**
	 * 初回も含めてウィンドウが開くとき
	 */
	public static class Shown extends NitrogenEventNeonComponent
	{

		public Shown(Window window, Neon neon, ComponentEvent event)
		{
			super(window, neon, event);
		}

	}

	/**
	 * disposeも含めてウィンドウが閉じるとき
	 */
	public static class Hidden extends NitrogenEventNeonComponent
	{

		public Hidden(Window window, Neon neon, ComponentEvent event)
		{
			super(window, neon, event);
		}

	}

	/**
	 * disposeするとき
	 */
	public static class Disposed extends NitrogenEventNeonWindow
	{

		public Disposed(Window window, Neon neon, WindowEvent event)
		{
			super(window, neon, event);
		}

	}

}
