package mirrg.swing.neon.v1_1;

import static org.junit.Assert.*;

import javax.swing.SwingUtilities;

import org.junit.Test;

import mirrg.swing.neon.v1_1.FrameNeon;
import mirrg.swing.neon.v1_1.NitrogenEventNeon;

public class TestFrameNeon
{

	@Test
	public void test1()
	{
		StringBuffer sb = new StringBuffer();

		FrameNeon frame = new FrameNeon();

		frame.neon.getEventManager().register(NitrogenEventNeon.Initialized.class, e -> sb.append("I"));
		frame.neon.getEventManager().register(NitrogenEventNeon.Shown.class, e -> sb.append("S"));
		frame.neon.getEventManager().register(NitrogenEventNeon.Hidden.class, e -> sb.append("H"));
		frame.neon.getEventManager().register(NitrogenEventNeon.Disposed.class, e -> sb.append("D"));

		SwingUtilities.invokeLater(() -> {
			assertEquals("", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(true);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("IS", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(false);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISH", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(true);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHS", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(false);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHSH", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(true);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHSHS", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.dispose();
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHSHSHD", sb.toString());
		});

	}

	@Test
	public void test2()
	{
		StringBuffer sb = new StringBuffer();

		FrameNeon frame = new FrameNeon();

		frame.neon.getEventManager().register(NitrogenEventNeon.Initialized.class, e -> sb.append("I"));
		frame.neon.getEventManager().register(NitrogenEventNeon.Shown.class, e -> sb.append("S"));
		frame.neon.getEventManager().register(NitrogenEventNeon.Hidden.class, e -> sb.append("H"));
		frame.neon.getEventManager().register(NitrogenEventNeon.Disposed.class, e -> sb.append("D"));

		SwingUtilities.invokeLater(() -> {
			assertEquals("", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(true);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("IS", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(false);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISH", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(true);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHS", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.setVisible(false);
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHSH", sb.toString());
		});
		SwingUtilities.invokeLater(() -> {
			frame.dispose();
		});
		SwingUtilities.invokeLater(() -> {
			assertEquals("ISHSHD", sb.toString());
		});

	}

}
